import javax.swing.*;    //Used by JDK 1.2 Beta 4 and all
import javax.swing.text.*; 
import javax.swing.event.*;
import javax.swing.filechooser.*;

import java.awt.*;
import java.awt.event.*;
import java.text.*;

/** ******************************************************************
  * A general dialog box with a message, yes/no buttons and an optional check box.
  * 
  */
class NGDialog
extends Dialog
implements ActionListener, ItemListener
{
    boolean result;
    boolean checkBoxState = false;
    WholeNumberField  zeilenField, spaltenField;
    DecimalField sperrField;
    Brett brett;
    
    public NGDialog(Brett parent, String msg) {
	super(parent, "Neues Spiel", true);
	brett = parent;
	//Fenster
	setBackground(Color.lightGray);
	setLayout(new BorderLayout());
	//setResizable(false);
	Point parloc = parent.getLocation();
	setLocation(parloc.x + 30, parloc.y + 30);
	
	JPanel panel = new JPanel();
	panel.setLayout(new FlowLayout(FlowLayout.CENTER));


	JButton button = new  JButton("Los gehts");
	button.addActionListener(this);
	panel.add(button);

	JLabel zeilenLabel   = new JLabel( "Zeilen" );
	JLabel spaltenLabel  = new JLabel( "Spalten" );
	JLabel sperrLabel    = new JLabel( "Wahr. Sperrfeld" );
	
        //Create the text fields and set them up.
	int fieldLength = 6;
	zeilenField  = new WholeNumberField( brett.getZeilen(), fieldLength);  
	spaltenField = new WholeNumberField( brett.getSpalten(), fieldLength); 
	sperrField   = new DecimalField( brett.getSperrFeldProb(), fieldLength,
					 NumberFormat.getInstance());

	prepareLabelField( zeilenField, zeilenLabel, "Zeilen" );
	prepareLabelField( spaltenField, spaltenLabel, "Spalten" );
	prepareLabelField( sperrField, sperrLabel, "Sperren" );


	JPanel infoPane = new JPanel();
	infoPane.setLayout( new GridLayout( 0, 2) ); 
	infoPane.add( zeilenLabel );
	infoPane.add( zeilenField );
	infoPane.add( spaltenLabel );
	infoPane.add( spaltenField );
	infoPane.add( sperrLabel );
	infoPane.add( sperrField );

	//Buttons
	ButtonGroup group = new ButtonGroup();
 	JRadioButton cb;
 
	cb = new JRadioButton( "Einzelspieler" );
	if( brett.getMode() == Brett.SINGLE ) cb.setSelected( true );
	cb.addItemListener( this );
	group.add( cb );
	infoPane.add( cb );

	cb = new JRadioButton( "Computer" );
	if( brett.getMode() == Brett.COMPUTER ) cb.setSelected( true );
	cb.addItemListener( this );
	group.add( cb );
	infoPane.add( cb );


        add("Center", infoPane);  
	add("South", panel);
	
	pack();
    }

    /** ******************************************************************
     * Detect a event from the YES / NO buttons.
     */
    public void actionPerformed(ActionEvent event) {
	if( event.getActionCommand().equals("Los gehts") ) {
	    brett.setZeilen( zeilenField.getValue() );
	    brett.setSpalten( spaltenField.getValue() );
	    brett.setSperrFeldProb( sperrField.getValue() );
	    setVisible(false);
	    dispose();
	}
    }

    /** get the result from the YES/NO buttons */
    public boolean getResult() { return result; }
    /** get the result from the check box */
    public boolean getCheckboxResult() { return checkBoxState; }
    
    /** ******************************************************************
     * Detect the change in the check box.
     */
    public void itemStateChanged( ItemEvent e ) {
	JRadioButton cb = (JRadioButton) e.getItemSelectable();
	String name  = cb.getLabel();
	System.out.println( "Checkbox " + name);
	if( name.equals( "Einzelspieler" ) ) brett.setMode( Brett.SINGLE );
	if( name.equals( "Computer" ) )      brett.setMode( Brett.COMPUTER );
	checkBoxState = cb.isSelected();
    }

    /** ******************************************************************
     *  
     */
    void prepareLabelField( JTextField field, JLabel label, String text ) {
	field.addActionListener( this );
	field.setActionCommand( text );
    }
  
}

